<bugID>395739<Summary>adaptive learning (match entered text to selected item) in url bar autocomplete</Summary><Description>adaptive learning (match entered text to selected item) in url bar autocomplete

mconnor wrote:

&lt;mconnor&gt; which is kinda/sorta how quicksilver learns
&lt;mconnor&gt; though it remembers "fo" == "foo.com" rather than just making foo.com
&gt;rate higher for anything matching

faaborg wrote:

I think we should seriously consider this type of adaptive learning.  Another
difference is that the first match in Quicksilver is set as the default action
on enter (like Safari).

I'm not sure what the 5 delight items currently are, but what do people think about bumping the least interesting item for a quicksilver inspired adaptive learning algorithm in the location bar auto-complete?  (https://bugzilla.mozilla.org/show_bug.cgi?id=395446)

For instance, if every time you type "ph" you select a bookmark called "phonebook", that result will be bumped up in the results for "ph" in the future, even if you have a bookmark called "phishing UI" that has a much higher overall frecency than "phonebook."

The search in the location bar is already a killer feature, and I think this would streamline the interaction even more. 

beltzner wrote:

That sounds like a good modification to the frecency algorithm to me.

dietrich wrote:

alex, that'd be *very* cool. as this bug is closed, can you file a new bug,
clearly spec'ing out the behavior?

gavin wrote:

See also bug 370117: it has a patch that makes us keep a record of how many
times a form history autocomplete entries are used, so that we can sort them by
frequency of use in the dropdown. That patch implements a formhistory-specific
API, but we could instead modify nsIAutocompleteResult to enable the
autocompletecontroller to notify the nsIAutocompleteSearch implementations of a
selected result, and have it record that data and take it into account when it
performs searches.</Description></bugID>